Subject: Re: [bug#37478] [PATCH] Support canonical guix environment -l guix.scm.

From: Brett Gilio <[email-masked]>
Date: Mon, 09 Dec 2019 22:52:35 -0600

Jan Nieuwenhuizen <[email-masked]> writes:

> Ludovic Courtès writes:
>
>>> I often find myself typing `guix environment -l guix.scm' in the Guix
>>> source root and thought IWBN no make that "just work".  WYDT?
>>
>> IWBN, but…
>>
>>> -(define-module (guix))
>>> +(define-module (guix)
>>> +  #:use-module (guix git-download)
>>> +  #:use-module (guix gexp)
>>> +  #:use-module (guix packages)
>>> +  #:use-module (gnu packages package-management))
>>
>> … the (guix) module is a public module, and it must not depend on
>> anything but the (guix …) modules it imports.
>>
>> So unfortunately we can’t just do that.
>
> Hmm, and is there a difference between compile-time and run-time?  I do
> not understand the rules well enough here...
>
> So I guess that something vaguely this (I really don't like the
> command-line "parsing" bit, just a thought experiment)
>
> ;; Naive command-line parser: are we running from Guix source tree
> ;;    guix build -f guix.scm
> ;;    guix environment -l guix.scm
> ;; then return guix@git package
> (when (and (file-exists? "guix/gexp.scm")
>            (let ((len (length (command-line))))
>              (and (> len 3)
>                   (let ((tail (list-tail (command-line) (- len 3))))
>                     (or (equal? tail '("build" "-f" "guix.scm"))
>                         (equal? tail '("environment" "-l" "guix.scm")))))))
>   (let ((source-dir (dirname (current-filename))))
>     ((@ (guix packages) package)
>      (inherit (@ (gnu packages package-management) guix))
>      (version "git")
>      (source ((@ (guix gexp) local-file) source-dir
>               #:recursive? #t
>               #:select? ((@ (guix git-download) git-predicate) source-dir))))))
>
> is also not possible?  It is also starts to look like a kludge and hard
> to get right...bah :)
>
>> Perhaps we could have a ‘.guix.scm’ file though, or
>> ‘build-aux/guix.scm’, something like that?
>
> Yes...I was hoping that we could offer/advise something standardized
> that all guix'ified upstreams could/would use.  I think that I've seen
> `.guix.scm', but also a `guix.scm' that returns a manifest, so usage
> would be `guix environment -m guix.scm', and no way to build the package
> itself from git.
>
> Once Guix is blessed `the GNU System' (any day now ;-) we need to have a
> a thought-through proposal to amend standards.texi anyway.
>
> Greetings,
> janneke

Hey all, where are we standing with this currently? I think there has
been some recent revisions with how we are using the `-l` flag, and want
to see if this still needs to some work. I am happy to offer my help.

-- 
Brett M. Gilio
Homepage -- https://scm.pw/
GNU Guix -- https://guix.gnu.org/